<template>
 <div class="col s12 m6">
        <div>
          <div class="page-subtitle">
            <h4>Создать</h4>
          </div>

          <form @submit.prevent="submitHandler" >
            <div class="input-field">
              <input v-model="title"
                  id="name"
                  type="text"
                  :class="{invalid: v$.title.$dirty && !v$.title.required }"
              >
              <label for="name">Название</label>
 <small class="helper-text invalid" v-for="(error, index) of v$.title.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>

              <!-- <span v-if="v$.title.$dirty && !v$.title.required" class="helper-text invalid">Введите название</span> -->
            </div>

            <div class="input-field">
              <input v-model.number="limit"
                  id="limit"
                  type="number"
                  :class="{invalid: v$.limit.$dirty && !v$.limit.minValue }"
              >
              <label for="limit">Лимит</label>
               <small class="helper-text invalid" v-for="(error, index) of v$.limit.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>
              <!-- <span v-if="v$.limit.$dirty && !v$.limit.minValue" class="helper-text invalid">Минимальная величина</span> -->
            </div>

            <button class="btn waves-effect waves-light" type="submit">
              Создать
              <i class="material-icons right">send</i>
            </button>
          </form>
        </div>
      </div>
</template>

<script>
import { useVuelidate } from "@vuelidate/core";
import { required, minValue } from "@vuelidate/validators";

export default{
    setup() {
    return { v$: useVuelidate() };
  },
    data:()=>({
        title:'',
        limit:1
    }),
    mounted(){
        M.updateTextFields();
    },
   validations() {
    return {
      title: { required },
      limit: { required, minValue: minValue(1) }
    };
  },
  methods: {
    async submitHandler() {
      this.v$.$touch();
      if (this.v$.$error) return;

      const formdata = {
        title: this.title,
        limit: this.limit
      };

      try{ 
          const category=await this.$store.dispatch('createCategory',formdata);
          // const category={title: formdata.title, limit: formdata.limit, id:Math.random().toString(36).slice(2)};
        //   console.log(category);
          this.title='';
          this.limit=1;
          this.v$.$reset();
          this.$message('Category is created');
          this.$emit('created',category);
        // await this.$store.dispatch('register',formdata);

        // this.$router.push("/home");
      }catch(e){
        console.log({e});
         this.$error(e.code);
        // this.$error(messages[this.$route.query.message] || "Nima xato ketganini tushunmadim")
      }
      
    }
  }

}
</script>